<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\SensorDeFluxoService;
use FM\Traits\TResponse;

class SensorDeFluxoController extends FMCrud{
    
    use TResponse;
    
    protected $SensorDeFluxoService;
   
    public function __construct($crudService, $environment, SensorDeFluxoService $SensorDeFluxoService) {
        parent::__construct($crudService, $environment);
        $this->SensorDeFluxoService = $SensorDeFluxoService;
    }
    
    public function getSensores(Request $request, Response $response){
        try {
            $data = $this->SensorDeFluxoService->getSensores();
            $this->sendResponse($data, 200);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function Sensores(Request $request, Response $response){
      try {
        $dadosRecebido = $request->getParameters();
        $dadosJson = json_decode(json_encode($dadosRecebido), true);
        if(strval($dadosJson['securityToken']) == md5("Teknisa.\"".strval(date('d-m-Y H:i', strtotime("-1 minutes")))."\"") || strval($dadosJson['securityToken']) == md5("Teknisa\"".strval(date('d-m-Y H:i'))."\"")){
          $this->SensorDeFluxoService->Sensores($dadosJson);
          $this->sendResponse("OK", 200);
        }
      } catch (Exception $ex) {
        $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      }
        
    }
    
    public function getTokenSensores(Request $request, Response $response){
      try {
        $dadosRecebido = $request->getParameters();
        if($dadosRecebido[0] == 0){
            $dados = date('d-m-Y H:i', strtotime("-1 minutes"));
            $this->sendResponse($dados, 200);
        }
      } catch (Exception $ex) {
        $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      }
    }
    
    public function getInicioEDateSensor(Request $request, Response $response){
      try {
        $this->sendResponse($this->SensorDeFluxoService->getInicioEDateSensor($request->getParameters()), 200);
      } catch (Exception $ex) {
        $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      }
    }
    
    public function getCount(Request $request, Response $response){
      try {
        $this->sendResponse($this->SensorDeFluxoService->getCount($request->getParameters()), 200);
      } catch (Exception $ex) {
        $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      }
    }
    
    public function stopCount(Request $request, Response $response){
      try {
        $this->SensorDeFluxoService->stopCount($request->getParameters());
        $this->sendResponse("OK", 200);
      } catch (Exception $ex) {
        $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      }
    }
    
    public function resetCount(Request $request, Response $response){
      try {
        $this->SensorDeFluxoService->resetCount($request->getParameters());
        $this->sendResponse("OK", 200);
      } catch (Exception $ex) {
        $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      }
    }
}

?>