<?php

namespace FM\Service;

use FM\Factory\TipoManutencaoFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class TipoManutencaoService {

    protected $TipoManutencaoFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (EntityManager $entityManager, TipoManutencaoFactory $TipoManutencaoFactory, Environment $Environment, NewCode $newCode) {
        $this->TipoManutencaoFactory = $TipoManutencaoFactory;
        $this->connection            = $entityManager->getConnection();
        $this->Environment           = $Environment;
        $this->newCode               = $newCode;
    }

    public function inserirTipoManutencao($parametros) {
        $NRORG = 20;
        $this->connection->beginTransaction();

        try {

            $NRTIPOMANUTENCAO = $this->newCode->getCodeByTableName("FCM_TIPOMANUTENCAO", $NRORG, 1, 10, true);

            $parametrosTipo = array(
              "NRTIPOMANUTENCAO" => $NRTIPOMANUTENCAO,
              "NMTIPOMANUTENCAO" => $parametros['NMTIPOMANUTENCAO']
            );

            $this->TipoManutencaoFactory->inserirTipoManutencao($parametrosTipo);

            $this->connection->commit();
            $response = 'OK';

        } catch(\Exception $e) {
          $this->connection->rollback();
          $response = ($e->getMessage());
      }
       return $response;
    }
    
    public function getInformacoesTipoManutencao() {

        $infoTipo = $this->TipoManutencaoFactory->getInformacoesTipoManutencao();
        return $infoTipo;
    }
}

?>